// 2007.12.
//  minutes timer with voice IC APR9600
//
//
//                -------
//     N.C  RA2  |       | RA1  <--- HOLD-SW
//     N.C  RA3  |12F648 | RA0  N.C
//     N.C  RA4  |       | RA7/OSC1/CLKIN   N.C
//     N.C /MCLR |       | RA6/OSC2/CLKOUT  N.C
//     GND  Vss  |       | Vdd  5.0V
// /M1 <--- RB0  |       | RB7 ---> /M8
// /M2 <--- RB1  |       | RB6 ---> /M7
// /M3 <--- RB2  |       | RB5 ---> /M6
// /M4 <--- RB3  |       | RB4 ---> /M5
//                -------


/*
bit 15,14     not used
bit 13-4  3FF code protection disabled
bit 3	  0   power-up timer is enabled
bit 2     0   watchdog timer is disabled
bit 10   10   HS oscillator
*/
// 0010 0001 0001 0000
#pragma config  = 0x2110

//------------------------------------------------

/***********/
/* DEFINES */
/***********/


#define TRUE                    1
#define FALSE                   0
#define	HIGH					1
#define LOW						0

//-----------------------------------------------------------
void delay_ms( uns16 millisec)
// Delays a multiple of 1 milliseconds at 4 MHz
// using the TMR0 timer
{
    char next = 0;

    OPTION = 2; // prescaler divide TMR0 rate by 8
    TMR0 = 2;  // deduct 2*8 fixed instruction cycles delay
    do  {
        next += 125;
        while (TMR0 != next)   // 125 * 8 = 1000 (= 1 ms)
            ;
    } while ( -- millisec != 0);
}
//-----------------------------------------------------------

void main( void)
{
	CMCON = 0x07;		//Comparator setting , not use comparat
	PORTA = 0x00;
 	TRISA = 0x02;		//RA1=input RA0,2,3,4=output
	PORTB = 0xFF;
	TRISB = 0x00;		//RB0,1,2,3,4,5,6,7 = output
 	OPTION = 0x82;		// bit7 1 portb pullup disable
						// bit6 0 int edge fall
						// bit5 0 TMR0 clock source is internal
						// bit4 0 TMR0 source edge rise of RA4/T0CKI
						// bit3 0 prescaler is assigned to the TMR0
						// bit210 010 prescaler rate 1:8
 	TMR0 = 0;

	unsigned int j,tmp,minutes;
	unsigned long i,count_min;

	count_min=65476;	// for 1 minute
	minutes=0;

//debug
RA2=HIGH;
//----------------------- wait 1sec at power on
	delay_ms(1000);

//debug
RA2=LOW;
delay_ms(500);
RA2=HIGH;

//----------------------- wait if HOLD SW is on(=holded)

LOOP1:
	if(RA1==0)
		goto LOOP1;

// take off sound
	RB6=LOW;
	delay_ms(400);		//400msec wait
	RB6=HIGH;

//------------------ now HOLD SW is off(= Not holded)
while(TRUE){

//----------------------- 1min wait with HOLD check
	j=0;
	do{
		i=0;
		do{

//----------------------- HOLD SW ON check
		if( RA1==0 ){
LOOP2:
			if(RA1==0)
				goto LOOP2;

//----------------------- HOLD SW OFF, go to next
			delay_ms(100);
			RB6=LOW;		//Take Off
			delay_ms(400);	//400msec wait
			RB6=HIGH;
		}

		i++;
		}while(i != count_min);
	j++;
	}while(j != 60);

//----------------------- voice start
	switch(minutes){
	//1min
	  case 0:
			RB0=LOW;		//1 minute passed
			delay_ms(400);		//400msec wait
			RB0=HIGH;
			break;
	//2min
	  case 1:
			RB1=LOW;		//2 minutes passed
			delay_ms(400);		//400msec wait
			RB1=HIGH;
			break;
	//3min
	  case 2:
			RB2=LOW;		//3 minutes passed
			delay_ms(400);		//400msec wait
			RB2=HIGH;
			break;
	//4min
	  case 3:
			RB3=LOW;		//4 minutes passed
			delay_ms(400);		//400msec wait
			RB3=HIGH;
			break;
	//5min
	  case 4:
			RB4=LOW;		//5 minutes passed
			delay_ms(400);		//400msec wait
			RB4=HIGH;
			break;
	  default:
			RB5=LOW;		//bingo, bingo
			delay_ms(400);		//400msec wait
			RB5=HIGH;
			break;
	}	// end of switch


	if( minutes<5 ){
		minutes++;
	}
	else{
		minutes=5;
		count_min=21825;	// 30sec parameter
	}


}	// end of while
}	// end of main
